/** 
 * @file yfrobot
 * @brief YFROBOT's sensors Mind+ library.
 * @n This is a MindPlus graphics programming extension for YFROBOT's module.
 * 
 * @copyright    YFROBOT,2022
 * @copyright    MIT Lesser General Public License
 * 
 * @author [email](yfrobot@qq.com)
 * @date  2022-11-10
*/

/*
enum IrButton {
    //% block="A"
    0xFFA25D,
    //% block="B"
    0xFF629D,
    //% block="C"
    0xFFE21D,
    //% block="D"
    0xFF22DD,
    //% block="︿"
    0xFF02FD,
    //% block="E"
    0xFFC23D,
    //% block="＜"
    0xFFE01F,
    //% block="۞"
    0xFFA857,
    //% block="＞"
    0xFF906F,
    //% block="0"
    0xFF6897,
    //% block="﹀"
    0xFF9867,
    //% block="F"
    0xFFB04F,
    //% block="1"
    0xFF30CF,
    //% block="2"
    0xFF18E7,
    //% block="3"
    0xFF7A85,
    //% block="4"
    0xFF10EF,
    //% block="5"
    0xFF38C7,
    //% block="6"
    0xFF5AA5,
    //% block="7"
    0xFF42BD,
    //% block="8"
    0xFF4AB5,
    //% block="9"
    0xFF52AD,
}

enum IrButtonHandle {
    //% block="↑"
    0xE49B11EE,
    //% block="↓"
    0xE49B916E,
    //% block="←"
    0xE49B817E,
    //% block="→"
    0xE49BA15E,
    //% block="M1"
    0xE49BE916,
    //% block="M2"
    0xE49B6996,
    //% block="A"
    0xE49B21DE,
    //% block="B"
    0xE49B01FE,
}
*/
enum IrButton {
    //% block="A"
    "FFA25D",
    //% block="B"
    "FF629D",
    //% block="C"
    "FFE21D",
    //% block="D"
    "FF22DD",
    //% block="︿"
    "FF02FD",
    //% block="E"
    "FFC23D",
    //% block="＜"
    "FFE01F",
    //% block="۞"
    "FFA857",
    //% block="＞"
    "FF906F",
    //% block="0"
    "FF6897",
    //% block="﹀"
    "FF9867",
    //% block="F"
    "FFB04F",
    //% block="1"
    "FF30CF",
    //% block="2"
    "FF18E7",
    //% block="3"
    "FF7A85",
    //% block="4"
    "FF10EF",
    //% block="5"
    "FF38C7",
    //% block="6"
    "FF5AA5",
    //% block="7"
    "FF42BD",
    //% block="8"
    "FF4AB5",
    //% block="9"
    "FF52AD",
}

enum IrButtonHandle {
    //% block="↑"
    "E49B11EE",
    //% block="↓"
    "E49B916E",
    //% block="←"
    "E49B817E",
    //% block="→"
    "E49BA15E",
    //% block="M1"
    "E49BE916",
    //% block="M2"
    "E49B6996",
    //% block="A"
    "E49B21DE",
    //% block="B"
    "E49B01FE",
}


//% color="#0eb83a" iconWidth=50 iconHeight=40
namespace AbotIR {
    let irObject = `irrecv`;
    //% block="读取[PIN]端口红外值" blockType="reporter"
    //% PIN.shadow="dropdown" PIN.options="PIN_DigitalWrite"
    export function readIR(parameter: any, block: any) {
        let irPin = parameter.PIN.code;
        Generator.addInclude(`Include_IRremote`, `#include <DFRobot_IRremote.h>`)
        Generator.addObject(`Object_IRremote_Receive`, `IRremote_Receive`, `${irObject}_${irPin};`);
        Generator.addSetup(`${irObject}_${irPin}_begin`, `${irObject}_${irPin}.begin(${irPin});`);
        Generator.addCode(`${irObject}_${irPin}.getIrCommand()`);
    }

/*
    //% block="值为[IRVAL]值" blockType="boolean"
    //% IRVAL.shadow="dropdown"   IRVAL.options="IrButton"     IRVAL.defl=IrButton.0xFFA25D
    export function IRVal(parameter: any, block: any) {
        let minibtnval = parameter.IRVAL.code;
        Generator.addCode(`results.value == ${minibtnval}`);
    }

    //% block="恢复读取红外值" blockType="command"
    export function readIRResume(parameter: any, block: any) {
        Generator.addCode(`${irObject}.resume();`);
    }

    
    //% block="红外接收数值为[IRHANDVAL]值(手柄式)" blockType="boolean"
    //% IRHANDVAL.shadow="dropdown"   IRHANDVAL.options="IrButtonHandle"     IRHANDVAL.defl=IrButtonHandle.0xE49BE916
    export function IRVal_handle(parameter: any, block: any) {
        let Handlebtnval = parameter.IRHANDVAL.code;
        Generator.addCode(`results.value == ${Handlebtnval}`);
    }
*/
   //% block="红外遥控器[BTN]值" blockType="reporter"
    //% BTN.shadow="dropdown"   BTN.options="IrButton"     BTN.defl=IrButton."FFA25D"
    export function IRMiniValue(parameter: any, block: any) {
        let minibtnval = parameter.BTN.code;
        Generator.addCode(`${minibtnval}`);
    }
    //% block="红外遥控器[BTNH]值(手柄式)" blockType="reporter"
    //% BTNH.shadow="dropdown"   BTNH.options="IrButtonHandle"     BTNH.defl=IrButtonHandle."E49BE916"
    export function IRHandleValue(parameter: any, block: any) {
        let Handlebtnval = parameter.BTNH.code;
        Generator.addCode(`${Handlebtnval}`);
    }

}
