enum SIZE {
    //% block="29*29"
    1,
    //% block="58*58"
    2
}

enum LINE {
    //% block="1"
    1,
    //% block="2"
    2,
    //% block="3"
    3,
    //% block="4"
    4
}

enum BTN {
    //% block="A"
    A,
    //% block="B"
    B,
    //% block="A+B"
    AB
}

enum KAIGUAN {
    //% block="开"
    HIGH,
    //% block="关"
    LOW
}

enum PIN_DWrite {
    //% block="0(RX)"
    D0,
    //% block="1(TX)"
    1,
    //% block="2"
    2,
    //% block="3"
    3,
    //% block="4"
    4,
    //% block="5"
    5,
    //% block="6"
    6,
    //% block="7"
    7,
    //% block="8"
    8,
    //% block="9"
    9,
    //% block="10(SS)"
    10,
    //% block="11(MOSI)"
    11,
    //% block="12(MISO)"
    12,
    //% block="13(LED/SCK)"
    13,
    //% block="A0"
    A0,
    //% block="A1"
    A1,
    //% block="A2"
    A2,
    //% block="A3"
    A3,
    //% block="A4(SDA)"
    A4,
    //% block="A5(SCL)"
    A5
}

enum ODMONOFF {
    //% block="OFF"
    LOW,
    //% block="ON"
    HIGH
}

enum OUTPUTMODULEDIGITAL {
    //% block="LED"
    LED,
    //% block="Active Buzzer"
    BUZZERACTIVE,
    //% block="Fan"
    FAN,
    //% block="Vibration Motor"
    VIBRATIONMOTOR,
    //% block="Relay"
    RELAY
}

enum OUTPUTMODULEANALOG {
    //% block="LED"
    LED,
    //% block="Fan"
    FAN,
    //% block="Vibration Motor"
    VIBRATIONMOTOR
}

enum IICMOTOR {
    //% block="M1"
    M1,
    //% block="M2"
    M2,
    //% block="M3"
    M3,
    //% block="M4"
    M4
}

enum IICMOTORSTOP {
    //% block="M1"
    M1,
    //% block="M2"
    M2,
    //% block="M3"
    M3,
    //% block="M4"
    M4,
    //% block="MAll"
    MAll
}

enum MOTORDIR {
    //% block="CW"
    CW,
    //% block="CCW"
    CCW
}

//% color="#4d9721" iconWidth=40 iconHeight=40
namespace i2cmotorDrive {

    //% block="I2C Motor Drive initliallize" blockType="command"
    export function init(parameter: any, block: any) {
        Generator.addInclude("includeMotorDriver", `#include \"MotorDriver.h\"`);
        Generator.addInclude("defineMotorDriver", `#define MOTORTYPE YF_IIC_TB`);
        Generator.addInclude("defineSerialDebug", `uint8_t SerialDebug = 1;`);
        Generator.addObject("motorDriveObject", `MotorDriver`, `i2cMotor = MotorDriver(MOTORTYPE);`);
        Generator.addSetup(`initSetup`, `i2cMotor.begin();`);
        Generator.addSetup(`initSetup2`, `i2cMotor.motorConfig(1, -1, 1, -1);`);
    }
    
    //% block="Drive single motor [MX] [MXVALUE]" blockType="command"
    //% MX.shadow="dropdown" MX.options="IICMOTOR" MX.defl=IICMOTOR.menu.2
    // MXDIR.shadow="dropdown" MXDIR.options="MOTORDIR"
    //% MXVALUE.shadow="range" MXVALUE.params.min=-4096 MXVALUE.params.max=4096 MXVALUE.defl=0
    export function setSingleMotor(parameter: any, block: any) {
        let mx = parameter.MX.code;
        // let mxdir = parameter.MXDIR.code;
        let mxval = parameter.MXVALUE.code;
        Generator.addCode(`i2cMotor.setSingleMotor(${mx},${mxval});`);
    }

    //% block="Drive All motor [MXVALUE]" blockType="command"
    //% MXVALUE.shadow="range" MXVALUE.params.min=-4096 MXVALUE.params.max=4096 MXVALUE.defl=0
    export function setAllMotor(parameter: any, block: any) {
        let mxval = parameter.MXVALUE.code;
        Generator.addCode(`i2cMotor.setAllMotor(${mxval});`);
    }
    
    //% block="Drive motor [MX1VALUE] [MX2VALUE] [MX3VALUE] [MX4VALUE]" blockType="command"
    //% MX1VALUE.shadow="range" MX1VALUE.params.min=-4096 MX1VALUE.params.max=4096 MX1VALUE.defl=0
    //% MX2VALUE.shadow="range" MX2VALUE.params.min=-4096 MX2VALUE.params.max=4096 MX2VALUE.defl=0
    //% MX3VALUE.shadow="range" MX3VALUE.params.min=-4096 MX3VALUE.params.max=4096 MX3VALUE.defl=0
    //% MX4VALUE.shadow="range" MX4VALUE.params.min=-4096 MX4VALUE.params.max=4096 MX4VALUE.defl=0
    export function setMotor(parameter: any, block: any) {
        let mx1val = parameter.MX1VALUE.code;
        let mx2val = parameter.MX2VALUE.code;
        let mx3val = parameter.MX3VALUE.code;
        let mx4val = parameter.MX4VALUE.code;
        Generator.addCode(`i2cMotor.setMotor(${mx1val},${mx2val},${mx3val},${mx4val});`);
    }

    //% block="Stop motor [MX]" blockType="command"
    //% MX.shadow="dropdown" MX.options="IICMOTORSTOP" MX.defl=IICMOTORSTOP.menu.2
    export function stopMotor(parameter: any, block: any) {
        let mx = parameter.MX.code;
        Generator.addCode(`i2cMotor.stopMotor(${mx});`);
    }

}
